.TH ACTX 1 "December 13,2001" "" "ActX  - Activate X Window System - Users Manual"
.SH "NAME"
ActX \- Activate X Window System
.SH "SYNOPSIS"
.B actx
[
.B options ...
]
[
.I mascot-option
]
.br
.B actx
[
.B options ...
]
.I -random
.SH "DESCRIPTION"
.B ActX
is a sort of "Window sitter" programs, which makes xpm mascots sit on
the focus window in X Window System.
.br
.br
The mascot packages of
.B ActX
are constructed by xpm files and one
.I .actx
file (called
.I mascot module
),
which describes the configuration of the mascot.
You can also build up your own favorite mascot for yourselves.
.br
Please enjoy your X-life, using this application!
.SH "ENVIRONMENT"
.B ActX
is running on
.I X Window System
(over 256 colors are necessary)
of any UNIX operating systems.
Furthermore,
.B ActX
could be running on any Window Managers without any problems.
.SH "BASIC OPERATION"
-The right click for popup menu, on which you can change configuration
of the program, change mascots and exit from the program.
If you want to save your changes, you should execute "Save Parameter"
in the popup menu.

.br
-The left drag for mascot's horizontal position change.
You can also change vertical position by the middle drag.

.br
-The left click causes "Click Animation", "Sound Playback" &
"Balloon Talk" on the mascot.

.br
-If you started it with the biff-mode,
the biff bitmap appears in the case that you have new (or unread) mails.
The left click on this biff bitmap enables you to check From: & Subject:
of unread mails.
The right click starts the mailer command.
.SH "OPTIONS"
Usually, command line options needed at least is either
[
.B mascot-option
]
, defined for each mascots,
or
.B -random
option.
If you choose any
.B mascot-option
, the chosen mascot will be displayed.
The
.B -random
options will be selected one from all installed mascots in the menu.
.br
Installed mascots and command line options can be showed by
.B -help
options.
.PP
All command line options...
.TP 10
.B -help
print out help message.
.TP 10
.B -biff
start with the biff (checking for mails) mode.
.TP 10
.B -init
In order to initialize user's mascots, 
user's mascot modules in 
.B HOME$/.actx/
directory are overwritten as 
modules in the default mascot directory, interactively.
.TP 10
.B -Init
Basically this option is same as the option,
.B -init.
But all modules are automatically overwritten.
.TP 10
.B -install
[
.I module-file
]
.br
install an append mascot modules to the
.B Default Mascot Directory
, which are showed by
.TP 10
.B -Install
[
.I module-file
]
.br
Basically this option is same as the option,
.B -install.
But, even in the case of the modules already installed,
they are automatically overwritten.
.TP 10
.B -home
[
.I X
] [
.I Y
]
.br
set the default position of the mascot in the case of no
focus window (
.B Home Position
).
.TP 10
.B -mapmode
[
.I mode
]
.br
select the mascot mapping mode by the value of [ mode ].
.RS
.IP
0 : Normal mapping (Default)
.br
1 : Redraw mode
.br
2 : Always on top (same as
.B -top
option)
.RE
.IP
.TP 10
.B -mdir
print the
.B Default Mascot Directory.
.TP 10
.B -merge
[
.I module-file
]
.br
merge the mascot module to user's menu resource file (default : HOME$/.actxrc).
.br
It is necessary that the module-file has been already installed by
.B -install.
.TP 10
.B -Merge
[
.I module-file
]
.br
Basically this option is same as the option,
.B -merge.
But, even in the case of the modules already merged to user's 
.B HOME$/.actx/
directory, they are automatically overwritten.
.TP 10
.B -mergeno
[
.I menu No.
]
.br
merge the mascot module to selected [ menu No. ] in the menu resource file.
.br
Please use with
.B -merge
option.
Without this option, the module added at the last of the menu.
.TP 10
.B -noanim
suppress the Superfluous Animation at the mascot change.
.TP 10
.B -noballoon
suppress the Balloon Talk by the left click on the mascot.
.TP 10
.B -nohome
ignore the setting of Home Position in the menu resource file.
.TP 10
.B -nomenu
suppress the appearance of the popup menu by the right click on the mascot.
.br
You can save about 1.5MB memory.
.br
If you use this option,
the program will be terminated by <CTRL>+ right click on the mascot.
.TP 10
.B -offset
[
.I off(%)
]
.br
map the mascot [ off ] pixel left from the standard position.
.br
When you want to run some
.B ActX
.br
Otherwise, if you add "%" to [ off ] value,
the mascot appears at the [ off ]% from the right edge of the title bar.
In this case, the drag of the mascot is forbidden.
.TP 10
.B -rcfile (-r)
[
.I resource-file
]
.br
select the menu resource file (default : 
.B HOME$/.actxrc
).
.TP 10
.B -redraw
[
.I frames
]
.br
set the number of frames to be redrawn in "Redraw-mode".
You have to use this option with
.B -mapmode 1
option, always.
.TP 10
.B  -sigmode
[
.I mode
]
.br
select the operation of time signal by the value of [ mode ].
.RS
.IP
0 : Click sound playback only
.br
1 : Random change of the mascot (default)
.br
2 : Sequential change of the mascot
.RE
.IP
Simultaneously
.B -signal
option is necessary
.TP 10
.B -signal
start with the time signal mode.
.TP 10
.B -sticky
suppress to follow the focus window.
With this option, you appointed the position of the mascot by
.B -geometry
option of X-Toolkit.
.TP 10
.B -titlebar
[
.I bar_size
]
.br
designate the size (in pixels) of the window titlebar,
added by each window managers,
manually.
.br
Usually,
this option is not necessary because
.B ActX
can automatically scale it.
.TP 10
.B -top
same as 
.B -mapmode 2
option.
.br
The mascot is mapped always on top.
.TP 10
.B -x
[
.I xoff
]
.TP 10
.B -y
[
.I yoff
]
.br
designate map offset (in pixels) of the mascot
started with
.B -xpm
option.
.TP 10
.B -xpm
[
xpm-file
]
.br
directly appoint the mascot xpm-file without the menu resource file.
.br
It is necessary the [xpm-file] has been already installed to the
.B Default Mascot Directory.
.SH "Configuration in $HOME/.Xdefaults"
If you use Japanized menu by I18N function of X Toolkit,
you have to add the following designation to your
.I $HOME/.Xdefaults

.br
	Actx*international: true
.br
	Actx*FontSet: -*-fixed-medium-r-normal--14-*
.br
	 (This fontset should be changed for environment of yourselves.)
.br

Furthermore, the Japanese input by kinput2 is available.
You can also add this line.

.br
	Actx*inputMethod:   kinput2
.br

.SH "Configuration for Sound"
In the menu resource file,
you have to appoint the following lines.

.br
	(Sound play command)	Actx*sndCom:
.br
	(Sound file directory)	Actx*sndDir:
.br

In each mascot module files,
you also have to appoint the following lines.

.br
	(Click sound file)	Actx*menuX.sndClk:
.br
	(Biff sound file)	Actx*menuX.sndMail:
.br

In command strings designated by "sndCom",
"%s" means sound filename, likely

.br
	cat %s > /dev/audio
.br
.SH "Configuration for Biff"
.B ActX
has the biff function for UNIX mbox, the log file of procmail and
qmail Maildir type mail spool.
And POP3 or POP3 with APOP access to the mail server is supported.
.br
In the
.I General Config
of the popup menu,

.br
	-type of biff mode
.br
	-the file (or directory for qmail) to be checked
.br
	-update command for mail (fetchmail etc.)
.br
	-update interval & indicate time for the biff balloon
.br
	-mail server & user name & password for POP3(APOP)
.br
	-command for the mailer
.br
	-decode command for MIME header (for I18N environment)
.br

can be appointed.
.SH "FILES"
.ta \w'*.com *.exe    'u
.if n .ta 2.5i
.if t .ta 1.8i
HOME$/.actxrc	the menu resource file (default)
.br
HOME$/.actx/*	the mascot module files (for uses' configuration)
.br
[Default Mascot Dir.]/*	the mascot modules and xpm files
.SH "AUTHOR"
.nf
Kurumi Chimari	<chimari@kurumi.sakura.ne.jp>
.br
  URL:   http://kurumi.sakura.ne.jp/~chimari/
.fi