#!/bin/sh
# ActX version 1.22sp : Auto-Configuration Script

VERSION="1.22sp"
PATH=.:$PATH
  
DEFAULT_CC="cc"
DEFAULT_I18N="y"
DEFAULT_KINDAW="1"
DEFAULT_BINDIR=$HOME/bin
DEFAULT_MASCOTDIR=$HOME/lib/ActX
DEFAULT_VOODOO="n"
DEFAULT_INSTALL_MENU="y"

IMAKE_FILE="./Imakefile"
RC_FILE="./install.actxrc"
RC_ONE="./install.actxrc-one"
#RC_KANON="./install.actxrc-kanon"
#RC_TRH="./install.actxrc-trh"
#RC_TSUKI="./install.actxrc-tsukihime"
#RC_PIA2="./install.actxrc-pia2"

echo "This is the install configuration for ActX version$VERSION."
echo ""
echo "Please answer following some questions."
echo " The values inside of [ ] are default ones."
echo "  If you hit CR without any letters, I select these ones."
echo ""

if [ "$HOME" = "/root" ] ; then
    echo ""
    echo "!!!!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!!!"
    echo "  This script is operated by root-user."
    echo "  This script is installing config file [.actxrc] to the operating user's Home Directry."
    echo "  So, I recommend you to use your usual account."

ROOT_FLAG=""
while [ "$ROOT_FLAG" = "" ]
do
    echo "Continue? (y/[n]) :" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT="n"
    fi
    if [ "$INPUT" = "n" ] ; then
	ROOT_FLAG="exit"
	exit
    fi
    if [ "$INPUT" = "y" ] ; then
	ROOT_FLAG="go"
	echo "... to the next step ..."
    fi
done
fi

I18N=""
while [ "$I18N" = "" ]
do
    echo ""
    echo "Do you support i18n (for Japanese)? ([y]/n) :" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT=$DEFAULT_I18N
    fi
    if [ "$INPUT" = "n" ] ; then
	echo "#undef USE_I18N"  > $IMAKE_FILE
	I18N="n"
    fi
    if [ "$INPUT" = "y" ] ; then
	echo "#define USE_I18N" > $IMAKE_FILE
	I18N="y"
    fi
	RC_SAMPLE="./build/actxrc"
	RC_SAMPLE_ONE="./build/actxrc-one"
#	RC_SAMPLE_KANON="./build/actxrc-kanon"
#	RC_SAMPLE_TRH="./build/actxrc-trh"
#	RC_SAMPLE_TSUKI="./build/actxrc-tsukihime"
#	RC_SAMPLE_PIA2="./build/actxrc-pia2"
done
	echo ""                 >> $IMAKE_FILE


VOODOO=""
while [ "$VOODOO" = "" ]
do
    echo ""
    echo "Are you using Voodoo3 or Banshee for XFree86 3.3.5 before? (y/[n]) :" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT=$DEFAULT_VOODOO
    fi
    if [ "$INPUT" = "n" ] ; then
	echo "#undef USE_VOODOO"  >> $IMAKE_FILE
	VOODOO="n"
    fi
    if [ "$INPUT" = "y" ] ; then
	echo "#define USE_VOODOO" >> $IMAKE_FILE
	echo "###########################################################################"
	echo " There are some serious bugs in the Voodoo engine of XFree86 3.3.5 before."
	echo " To avoid this bugs, the drag motion of mascots will be forbidden."
	echo "###########################################################################"
	echo ""
	VOODOO="y"
    fi
done
	echo ""                 >> $IMAKE_FILE


KINDAW=""
while [ "$KINDAW" = "" ]
do
    echo ""
    echo "Which Athena Widget do you use?"
    echo " ================================"
    echo " 1. normal athena widget (libXaw)"
    echo " 2. Xaw3d"
    echo " 3. neXtaw"
    echo " 4. libXaw (Version 5 or before)"
    echo " ================================"
    echo "  (If you do not understand, just hit CR.) (1-4 [1]):" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT=$DEFAULT_KINDAW
    fi
    if [ "$INPUT" = "1" ] ; then
	echo "#undef NEXTAW" >> $IMAKE_FILE
	echo "#undef XAW3D" >> $IMAKE_FILE
	echo "#undef USE_XAW5" >> $IMAKE_FILE
	echo ""
	echo "  If the version of your libXaw is 5 or berfore it (like Solaris), Please select 4."
	echo ""
	KINDAW="1"
    fi
    if [ "$INPUT" = "2" ] ; then
	echo "#undef NEXTAW" >> $IMAKE_FILE
	echo "#define XAW3D" >> $IMAKE_FILE
	echo "#undef USE_XAW5" >> $IMAKE_FILE
	echo ""
	echo "  Now using Xaw3d ..."
	echo "  Please confirm that header files for Xaw3d have been installed in /usr/include/X11/Xaw3d."
	echo ""
	KINDAW="2"
    fi
    if [ "$INPUT" = "3" ] ; then
	echo "#define NEXTAW" >> $IMAKE_FILE
	echo "#undef XAW3D" >> $IMAKE_FILE
	echo "#undef USE_XAW5" >> $IMAKE_FILE
	echo ""
	echo "  Now using neXtaw ..."
	echo "  Please confirm that header files for neXtaw have been installed in /usr/include/X11/neXtaw."
	echo ""
	KINDAW="3"
    fi
    if [ "$INPUT" = "4" ] ; then
	echo "#undef NEXTAW" >> $IMAKE_FILE
	echo "#undef XAW3D" >> $IMAKE_FILE
	echo "#define USE_XAW5" >> $IMAKE_FILE
	echo ""
	KINDAW="4"
    fi
done
    echo ""                >> $IMAKE_FILE


echo ""
echo "Where should ActX-binary be installed?  [$DEFAULT_BINDIR] :"

read INPUT
if [ "$INPUT" = "" ] ; then
    INPUT=$DEFAULT_BINDIR
fi
BINDIR=$INPUT

echo "BINDIR = $BINDIR" >> $IMAKE_FILE
echo ""                 >> $IMAKE_FILE

echo "  ... ActX bainary is installing to $BINDIR."
echo ""


echo ""
echo "Where should mascot data (.xpm) be installed?  [$DEFAULT_MASCOTDIR] :"

read INPUT
if [ "$INPUT" = "" ] ; then
    INPUT=$DEFAULT_MASCOTDIR
fi
MASCOTDIR=$INPUT

echo "#define MASCOTDIR $MASCOTDIR" >> $IMAKE_FILE
echo ""                             >> $IMAKE_FILE

cp -f $RC_SAMPLE.1 $RC_FILE
cp -f $RC_SAMPLE_ONE.1 $RC_ONE
#cp -f $RC_SAMPLE_KANON.1 $RC_KANON
#cp -f $RC_SAMPLE_TRH.1 $RC_TRH
#cp -f $RC_SAMPLE_TSUKI.1 $RC_TSUKI
#cp -f $RC_SAMPLE_PIA2.1 $RC_PIA2
echo "Actx*xpmDir: $MASCOTDIR" >> $RC_FILE
echo "Actx*xpmDir: $MASCOTDIR" >> $RC_ONE
#echo "Actx*xpmDir: $MASCOTDIR" >> $RC_KANON
#echo "Actx*xpmDir: $MASCOTDIR" >> $RC_TRH
#echo "Actx*xpmDir: $MASCOTDIR" >> $RC_TSUKI
#echo "Actx*xpmDir: $MASCOTDIR" >> $RC_PIA2
cat $RC_SAMPLE.2               >> $RC_FILE
cat $RC_SAMPLE_ONE.2               >> $RC_ONE
#cat $RC_SAMPLE_KANON.2               >> $RC_KANON
#cat $RC_SAMPLE_TRH.2               >> $RC_TRH
#cat $RC_SAMPLE_TSUKI.2               >> $RC_TSUKI
#cat $RC_SAMPLE_PIA2.2               >> $RC_PIA2

echo "   ... Mascot data are installing to $MASCOTDIR."
echo ""

echo "MASCOTDIR = $MASCOTDIR" >> $IMAKE_FILE
echo ""	>> $IMAKE_FILE
echo "DEFINES_MASCOTDIR = -DMASCOTDIR=\\\"$MASCOTDIR\\\"" >> $IMAKE_FILE
echo ""                             >> $IMAKE_FILE


#INSTALL_MENU=""
#while [ "$INSTALL_MENU" = "" ]
#do
#    echo ""
#    echo "Do you install the default menu resource file?"
#    echo "    #### If you already installed SP version from ActX CD, please say \"n\" ([y]/n) :" ; read INPUT
#    if [ "$INPUT" = "" ] ; then
#	INPUT=$DEFAULT_INSTALL_MENU
#    fi
#    if [ "$INPUT" = "n" ] ; then
#	echo "#undef INSTALL_DEFAULTMENU"  >> $IMAKE_FILE
#	INSTALL_MENU="n"
#    fi
#    if [ "$INPUT" = "y" ] ; then
    echo "#define INSTALL_DEFAULTMENU" >> $IMAKE_FILE
    INSTALL_MENU="y"
#    fi
#done
	echo ""                 >> $IMAKE_FILE


CC=""
echo ""
echo "Which compiler will you use?  [$DEFAULT_CC] :" ; read INPUT
if [ "$INPUT" = "" ] ; then
    INPUT=$DEFAULT_CC
fi
CC=$INPUT

echo "CC = $CC" >> $IMAKE_FILE
echo ""         >> $IMAKE_FILE


cat ./build/Imakefile.1 >> $IMAKE_FILE


echo "Now installing the config file $HOME/.actxrc."

if [ -f $HOME/.actxrc ] ; then
    echo " $HOME/.actxrc already exists. Overwirte? (y/[n]) :"
    echo "   (The existing file will be back-uped to $HOME/.actxrc-backup.)"
    
    
    read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT="n"
    fi
    if [ "$INPUT" = "y" ] ; then
	cp -f $HOME/.actxrc $HOME/.actxrc-backup
	cp -f $RC_FILE $HOME/.actxrc
	echo " $HOME/.actxrc is installed."
    else
	echo " $HOME/.actxrc is not installed."
	echo " Please confirm your configuration in $HOME/.actxrc."
    fi
else
    cp -f $RC_FILE $HOME/.actxrc
    echo " $HOME/.actxrc is installed."
fi

echo ""


echo "Now, configuration is finished."
echo "Please confirm built Imakefile, and use following commands"
echo "===================================================================="
echo "     xmkmf"
echo "     make"
echo "     su (if needed)"
echo "     make install  (install all files)"
echo "        make install.bin    (install only binary)"
echo "        make install.mascot (install only mascots)"
echo "     make install.man    (if you need man page : su needed)"
echo "     make install.jman   (if you need japanese man page : su needed)"
echo "     make install.locale (if you need default resource : su needed)"
echo "===================================================================="
echo ""

if [ "$I18N" = "y" ] ; then
    echo "To support i18n, please add this line to your $HOME/.Xdefaults etc."
    echo "   Actx*international:true"
    echo "Or,"
    echo "Please use  make install.locale  to install a resource to your app-defaults"
fi

if [ -d $HOME/.actx ] ; then
echo "############################################################"
echo "     It seems ActX has been already installed in your env."
echo "   So, please use this command,"
echo "      actx -Init"
echo "   in order to change modules in $HOME/.actx/ "
echo "   to the newest ones."
echo "############################################################"

fi




