#include "actx.h"
#include "mail.h"
#include "libpop.h"
#include <sys/stat.h>
#include <dirent.h>
#include <signal.h>
#include <time.h>

#define BUFFSIZE 200
#define BUFFSIZE5 1000

#define HEADER_MAX 256

void mail_check();
void mail_check_mbox();
void mail_check_mdir();
void mail_check_pop3();
void fs_get_procmail();
void fs_get_mbox();
void fs_get_qmail();
void fs_get_pop3();
void display_fs_get_pop3();
char* strbuf();
static char* code_conv();
void  set_biff_filter();
void  set_token();
int get_token2();
void display_biff_balloon();
void pop3_data_read();
int get_pop3();
void pop3_signal();

enum{ NODAT, STRING, ID, SYMBOL, RESERVE } TokenType;

extern sound_play();
extern ext_play();
extern void ChildTerm();         /* ҥץν */

extern XtIntervalId biff_id;
extern XtAppContext app;
extern Mailbox *mailbox;
extern Widget biff,mascot,mailwin_text;
extern char biff_command[512];
extern int biff_interval;
extern int statusBiffmap;
extern char biff_filter_com[512];
#ifdef SOUND
extern char snd_biff[128];
#endif
extern int biffmode;
extern int pop3_data_valid; 
extern Boolean interFlag;


extern int popReadLine();
extern int popWriteLine();

extern char pop3_server[512], pop3_user[512], pop3_pass[512];

Mailbox *mailbox;
char token_buf[BUFFSIZE+1];
static char *token_p;
static char *biff_filter[12];
time_t former_newest=0;

char *pop_froms = NULL;
int pop3_fd[2];
int pop3_child_fl = 0;
int child_fl = 0;

void biff_init(mbox_file)
    char *mbox_file;
{
#ifdef POP_DEBUG
  printf("Biff init\n");
#endif
    mailbox = (Mailbox *) malloc(sizeof(Mailbox));
    mailbox->path=mbox_file;
    mailbox->size=0;
    mailbox->last_check=0;
    mailbox->mail_count=0;
    mailbox->pop3_port = POP3_PORT_NO;
    mailbox->pop3_server = pop3_server;
    mailbox->pop3_user = pop3_user;
    mailbox->pop3_pass = pop3_pass;
    mailbox->status = NO_MAIL;
    XtFree(pop_froms);
    pop_froms=strbuf(NULL);
}    


void MailChecker(){
    ext_play(biff_command);  
    mail_check(mailbox);
    /*if((biffmode != TYPE_POP3)&&(biffmode != TYPE_APOP))*/
    biff_id=XtAppAddTimeOut(app, biff_interval * 1000, 
			    MailChecker, NULL);
    display_biff_balloon(mailbox);
}

void display_biff_balloon(Mailbox *mailbox)
{
    if((mailbox->status != NO_MAIL)&&(mailbox->status != POP3_ERROR)){
	if(statusBiffmap==0){
	    statusBiffmap=2;
	}
	else{
	    statusBiffmap=1;
	}
	XMapWindow(XtDisplay(biff),XtWindow(biff));

    }
    else if(mailbox->status == POP3_ERROR){
      statusBiffmap=0;
      XUnmapWindow(XtDisplay(biff),XtWindow(biff));
      DoBalloon(POP3_ERROR);
    }
    else{
	statusBiffmap=0;
	XUnmapWindow(XtDisplay(biff),XtWindow(biff));
    }
    if(mailbox->status==NEW_MAIL){
#ifdef SOUND
      	sound_play(snd_biff);
#endif
	DoBalloon(1);
    }
}

void mail_check(Mailbox *mbox){
  static struct sigaction act;

    switch(biffmode){     /* 0=mbox,  1=procmail,  2=maildir,  3=pop3,  4=apop*/
      case TYPE_MBOX: 
      case TYPE_PROCMAIL: 
	mail_check_mbox(mbox);
        break;
      case TYPE_MAILDIR: 
	mail_check_mdir(mbox);
        break;
      case TYPE_POP3: 
      case TYPE_APOP: 
	mail_check_pop3(mbox);
	act.sa_handler=pop3_signal;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	sigaction(SIGUSR1, &act,0);
	  /*signal(SIGUSR1,pop3_signal);*/
        break;
    }
}

void pop3_signal(int sig){
#ifdef POP_DEBUG
  fprintf(stderr, "get child end\n");
#endif
  /*if(pop3_data_valid == 1) {*/
  pop3_data_read(mailbox);
    /*}*/
}


void mail_check_pop3(Mailbox *mbox){

  int status = 0;
  static int pid;
  char *buff = NULL;
  char buf[BUFFSIZE];

  if( pop3_child_fl == 1){
    return ;
  }
  pop3_child_fl = 1;

  pipe(pop3_fd);
  waitpid(pid,0,WNOHANG);
 
  if( (pid = fork()) <0){
    fprintf(stderr,"fork error\n");
  }
  else if(pid ==0) {
#ifdef POP_DEBUG
    printf("child\n");
#endif
    status = get_pop3(mbox);
    XtFree(buff);
    buff = strbuf(NULL);
    sprintf(buf,"%d\n",mbox->status);
    buff = strbuf(buf);
    if(status != POP3_ERROR){
      sprintf(buf,"%d\n",mbox->mail_count);
      buff = strbuf(buf);
      buff = strbuf(pop_froms);
    }
#ifdef POP_DEBUG
    printf("%s",buff);
#endif
    close(STDOUT_FILENO);
    dup2(pop3_fd[1],STDOUT_FILENO);
    close(pop3_fd[0]);
    printf("%s",buff);
#ifdef POP_DEBUG
    fprintf(stderr, "child end\n");
#endif
    kill(getppid(), SIGUSR1);
    exit(0);
  }

}

int get_pop3(Mailbox *mbox)
{
  signed int ret;
  int num;
  long size;
  char apop_key[BUFFSIZE];

#ifdef POP_DEBUG
  printf("Conncet %s : %d\n", mbox->pop3_server, mbox->pop3_port);
#endif
  memset(apop_key, '\0', BUFFSIZE);
  ret = popConnect(mbox->pop3_server, mbox->pop3_port, apop_key);
  if( ret != 0 ){
    fprintf(stderr, "ERR: popConnect() [ret=%d]\n", ret);
    mbox->status = POP3_ERROR;
    return(POP3_ERROR);
  }

#ifdef POP_DEBUG
  printf("POP LOGIN %s %s %s\n",mbox->pop3_user, mbox->pop3_pass, apop_key);
#endif
  ret = popLogin(mbox->pop3_user, mbox->pop3_pass, apop_key);
  if( ret != 0 ){
    fprintf(stderr, "ERR: popLogin() [ret=%d]\n", ret);
    mbox->status = POP3_ERROR;
    popQuit();
    popClose();
    return(POP3_ERROR);
  }


#ifdef POP_DEBUG
  printf("POP STAT\n");
#endif
  ret = popStat(&num, &size);
  if( ret != 0 ){
    fprintf(stderr, "ERR: popStat() [ret=%d]\n", ret);
    mbox->status = POP3_ERROR;
    popQuit();
    popClose();
    return(POP3_ERROR);
  }
#ifdef POP_DEBUG
  printf("mail: %d, size: %ld\n", num, size);
#endif
  if(num == 0){
    mbox->status = NO_MAIL;
    XtFree(pop_froms);
    pop_froms = strbuf(NULL);
  }
  else{
    if(num == mbox->mail_count){
      mbox->status = KEEP_NEW_MAIL;      
    }
    else if(num > mbox->mail_count){  /* ᡼ */
      mbox->status = NEW_MAIL;
      fs_get_pop3(num,mbox);      
    }
    else{  /* ᡼äƤ餹٤ƿ᡼ȸʤ */
      mbox->status = NEW_MAIL;      
      pop_froms = strbuf(NULL);
      mbox->mail_count = 0;
      fs_get_pop3(num,mbox);
    }
  }
  popQuit();
  popClose();

#ifdef POP_DEBUG
  printf("data3 = %s\n",pop_froms);
#endif
  mbox->mail_count = num;
  return(mbox->status);
}


void pop3_data_read(Mailbox *mbox)
{
  FILE *fp;
  char buf[BUFFSIZE];

  if(pop3_child_fl == 1){
    XtFree(pop_froms);
    pop_froms = strbuf(NULL);
    close(pop3_fd[1]);
    if( (fp = fdopen( pop3_fd[0], "r" )) == NULL ){
      fprintf(stderr,"pipe open err\n");    
    }
    else{
      fgets( buf,BUFFSIZE-1,fp );
      mbox->status = atoi(buf);
      if( mbox->status < 0){
	fprintf(stderr,"POP3 error\n");
	mbox->mail_count = 0;
	mbox->status = POP3_ERROR;
      }
      else{
	fgets( buf,BUFFSIZE-1,fp );
	mbox->mail_count = atoi(buf);
	while( fgets( buf,BUFFSIZE-1,fp ) != NULL ){
	  pop_froms = strbuf( buf );
	}
      }
      fclose( fp );
    }
#ifdef POP_DEBUG
    printf("status = %d\n",mbox->status);
    printf("count = %d\n",mbox->mail_count);
    printf("data2 = %s\n",pop_froms);
#endif
    pop3_child_fl = 0;
    /*pop3_data_valid = 0;*/
    close(pop3_fd[0]);
  }
  /*display_biff_balloon(mbox);*/
}


void mail_check_mbox(Mailbox *mbox){
    struct stat t;
    DIR *dp;
    struct dirent *entry;
    char tmp[256];
    time_t newest_time=0;
    int filenum=0;
    int mc=0;
    FILE *fp;
    char buf[BUFFSIZE];

    if (!stat(mbox->path, &t)){
      if(t.st_size == 0){ /* ᥤե륵 */
	mbox->status = NO_MAIL;
	mbox->mail_count = 0;
      }
      else if (t.st_size < mbox->size){
	/* mailbox smaller in size; some mails have been deleted */
	mbox->status = OLD_MAIL;
      }
      else if (t.st_atime > t.st_mtime){ 
	/* mailbox read after most recent write */
	mbox->status = OLD_MAIL;
      }
      else if (t.st_size > mbox->size){
	/* mailbox modified after most recent read, and larger in size */
	/* this implies the arrival of some new mails */
	mbox->status = NEW_MAIL;
	/* get mail count */
	if((fp=fopen(mailbox->path,"r"))!= NULL){
	  do{
	    if(fgets(buf,BUFFSIZE-1,fp)==NULL) break;
	    if(strncmp(buf,"From ",5)==0){
	      mc++;
	    }
	  } while (1);
	  fclose(fp);
	  mbox->mail_count = mc;
	}
      }
      else if ((t.st_size == mbox->size)&&
	       ((mbox->status == NEW_MAIL)||(mbox->status ==KEEP_NEW_MAIL))){
	mbox->status=KEEP_NEW_MAIL;
      }
      else{
	mbox->status = NO_MAIL;          /* no such mailbox */
	mbox->mail_count = 0;
      }
    }
    else{ /* ᥤե뤬¸ߤʤȤ */
      mbox->status = NO_MAIL;  
      mbox->mail_count = 0;
    }
    mbox->size = t.st_size;
}


void mail_check_mdir(Mailbox *mbox){
    struct stat t;
    DIR *dp;
    struct dirent *entry;
    char tmp[256];
    time_t newest_time=0;
    int filenum=0;

    if ((dp=opendir(mbox->path))==NULL){
      mbox->status = NO_MAIL;  
      mbox->mail_count = 0;
      return;
    }
    
    while((entry=readdir(dp))!=NULL){
      if(entry->d_name[0]!='.'){
	sprintf(tmp,"%s/%s",mbox->path,entry->d_name);
	if (!stat(tmp, &t)){
	  filenum++;
	  if (t.st_mtime>newest_time){ 
	    newest_time=t.st_mtime;
	  }
	}
      }
    }
	
    closedir(dp);
	
    if(filenum==0){
      mbox->status = NO_MAIL;
      mbox->mail_count = 0;
    }
    else{
      if(newest_time==former_newest){
	mbox->status = KEEP_NEW_MAIL;  
      }
      else if(newest_time>former_newest){
	mbox->status = NEW_MAIL;  
      }
      else{
	mbox->status = OLD_MAIL;  
      }
    }
    former_newest=newest_time;
    mbox->mail_count = filenum;
}

/* pop3 server  From: Subject:  */
void fs_get_pop3(int num, Mailbox *mbox){

  int funcret;
  char buffer_header[HEADER_MAX][POP_MAX_LINE], bufs[BUFFSIZE5];
  char buffer[POP_MAX_LINE];
  int mail_cnt, header, header_line, i;

  char *f, *s, *sdel, *tmp_froms=NULL;

  tmp_froms=strbuf(NULL); 
  if (pop_froms != NULL) {
    tmp_froms=strbuf(pop_froms);
  }

#ifdef POP_DEBUG
  printf("fs read num = %d mail_count = %d\n", num, mbox->mail_count); 
#endif

  for(mail_cnt = (mbox->mail_count +1); mail_cnt <= num; mail_cnt++){

    sprintf(buffer, "TOP %d %d\r\n", mail_cnt, 0);  /* get header only */
#ifdef POP_DEBUG
    printf("TOP %d %d\n", mail_cnt, 0);  /* get header only */
#endif
    funcret = popWriteLine(buffer);
    if( funcret != 0 ){
      fprintf(stderr,"write err = %d\n",funcret);
      return;
    }
    for(header=0; header < HEADER_MAX; header++){
      funcret = popReadLine(buffer_header[header], POP_MAX_LINE);
      if( funcret != 0 ){
	fprintf(stderr,"read err\n");
	return;
      }
      if( strcmp(buffer_header[header], ".\r\n") == 0 )      break;
      buffer_header[header][strlen(buffer_header[header])-2]=' ';  /* \r delete */
    }
    header_line = header-1;

    f=s=NULL;
    for(header=0; header < header_line; header++){
      if((strncmp(buffer_header[header],"From:",5)==0)||
	 (strncmp(buffer_header[header],"FROM:",5)==0))
      {
	strcpy(bufs, buffer_header[header]);
	for(i=1;i<5;i++){
	  if((i+header) > header_line)  break;
	  if((buffer_header[i+header][0]==' ') || (buffer_header[i+header][0]=='\t')){
	    bufs[strlen(bufs)-2]='\0';
	    sdel = &buffer_header[i+header][1];     /* \t  */
	    strcat(bufs,sdel); /* ʣ */
	  }
	  else{
	    f=XtNewString(bufs);
	    break;
	  }
	}
      }
      else if((strncmp(buffer_header[header],"Subject:",8)==0)||
	      (strncmp(buffer_header[header],"SUBJECT:",8)==0))
      {
	strcpy(bufs, buffer_header[header]);
	for(i=1;i<5;i++){
	  if((i+header) > header_line)  break;
	  if((buffer_header[i+header][0]==' ') || (buffer_header[i+header][0]=='\t')){
	    bufs[strlen(bufs)-2]='\0';
	    sdel = &buffer_header[i+header][1];     /* \t  */
	    strcat(bufs,sdel); /* ʣ */
	  }
	  else{
	    s=XtNewString(bufs);
	    break;
	  }
	}
      }
    }
    
    if (f) {
      tmp_froms=strbuf(f);
      XtFree(f);
    }
    else{
      tmp_froms=strbuf("(no From: in original)\n");
    }
    if (s) {
      tmp_froms=strbuf(" ");
      tmp_froms=strbuf(s);
      XtFree(s);
    }
    else{
      tmp_froms=strbuf("(no Subject: in original)\n");
    }
  }
  XtFree(pop_froms);
  pop_froms=strbuf(NULL);
  pop_froms=strbuf(tmp_froms);
  XtFree(tmp_froms);
#ifdef POP_DEBUG
  printf("data = %s\n",pop_froms);
#endif
}

void display_fs_get_pop3(){

  static char *tmp_froms=NULL;
  
  tmp_froms=strbuf(NULL);
  tmp_froms=strbuf(pop_froms);

#ifdef I18N    
  if((strcmp(biff_filter_com,"\0")!=0)&&(interFlag==True)){
	set_biff_filter(biff_filter_com);
	tmp_froms=code_conv(tmp_froms);
    }
#endif
    
#if 0
    XtVaSetValues(mailwin_text, XtNstring, XtNewString(tmp_froms), NULL);
#endif
    XtVaSetValues(mailwin_text, XtNstring, tmp_froms, NULL);
}

void fs_get_procmail(char *mh_dir){
    FILE *fp,*fp_folder;
    char buf[BUFFSIZE],tmp[10],bufs[BUFFSIZE5];
    char folder_file[BUFFSIZE],folder_tmp[BUFFSIZE];
    char *froms=NULL, *p;
    Boolean ed_fl=False;
    fpos_t pos;
    int i;
    
    char *f, *s, *sdel;


    froms=strbuf(NULL);

    if((fp=fopen(mailbox->path,"r"))==NULL){
	return;
    }
    
    while(!feof(fp)){
	f=s=NULL;
	if(fgets(buf,BUFFSIZE-1,fp)==NULL) break;
	if(strncmp(buf,"  Folder:",9)==0){
	    sscanf(buf,"%s%s",tmp,folder_tmp);
	    sprintf(folder_file,"%s/%s",mh_dir,folder_tmp);

	    if((fp_folder=fopen(folder_file,"r"))!=NULL){
		while(!feof(fp_folder)){
		    if((p=fgets(buf,BUFFSIZE-1,fp_folder))==NULL
		       ||buf[0]=='\n'||buf[0]=='\0')
			break;
		    if((strncmp(buf,"From:",5)==0)||
		       (strncmp(buf,"FROM:",5)==0))
		    {
			strcpy(bufs,buf);
			for(i=0;i<5;i++){
			    fgetpos(fp_folder,&pos);
			    if((p=fgets(buf,BUFFSIZE-1,fp_folder))==NULL
			       ||buf[0]=='\n'||buf[0]=='\0'){
				ed_fl=True;
				break;
			    }
			    if(bufs[strlen(bufs)-1]!='\n'){
				strcat(bufs,buf); /* Ԥ200byteʾ */
			    }
			    else if((buf[0]==' ') || (buf[0]=='\t')){
				bufs[strlen(bufs)-1]='\0';
				sdel = &buf[1];     /* \t  */
				strcat(bufs,sdel); /* ʣ */
			    }
			    else{
				f=XtNewString(bufs);
				fsetpos(fp_folder,&pos);
				break;
			    }
			}
			if(ed_fl) break;
		    }
		    else if((strncmp(buf,"Subject:",8)==0)||
			    (strncmp(buf,"SUBJECT:",8)==0))
		    {
			strcpy(bufs,buf);
			for(i=0;i<5;i++){
			    fgetpos(fp_folder,&pos);
			    if((p=fgets(buf,BUFFSIZE-1,fp_folder))==NULL
			       ||buf[0]=='\n'||buf[0]=='\0'){
				ed_fl=True;
				break;
			    }
			    if(bufs[strlen(bufs)-1]!='\n'){
				strcat(bufs,buf); /* Ԥ200byteʾ */
			    }
			    else if((buf[0]==' ') || (buf[0]=='\t')){
				bufs[strlen(bufs)-1]='\0';
				sdel = &buf[1];     /* \t  */
				strcat(bufs,sdel); /* ʣ */
			    }
			    else{
				s=XtNewString(bufs);
				fsetpos(fp_folder,&pos);
				break;
			    }
			}
			if(ed_fl) break;
		    } 
		}
		fclose(fp_folder);
		/*
		 * From: Subject:
		 * νɽ
		 */
		if (f) {
		    froms=strbuf(f);
		    XtFree(f);
		}
		else{
		    froms=strbuf("(no From: in original)\n");
		}
		if (s) {
		    froms=strbuf(" ");
		    froms=strbuf(s);
		    XtFree(s);
		}
		else{
		    froms=strbuf("(no Subject: in original)\n");
		}

	    }
	}
	
    }
    fclose(fp);

#ifdef I18N    
    if(strcmp(biff_filter_com,"\0")!=0){
	set_biff_filter(biff_filter_com);
	froms=code_conv(froms);
    }
#endif
    
#if 0
    XtVaSetValues(mailwin_text, XtNstring, XtNewString(froms), NULL);
#endif
    XtVaSetValues(mailwin_text, XtNstring, froms, NULL);
}	

/* ᡼ܥå From: Subject:  */
void fs_get_mbox(){
    FILE *fp;
    char buf[BUFFSIZE],bufs[BUFFSIZE5];
    char *froms=NULL;
    char *p;
    Boolean ed_fl=False;
    fpos_t pos;
    int i;

    char *f, *s, *sdel;
    
    froms=strbuf(NULL);

    if((fp=fopen(mailbox->path,"r"))!= NULL){
	do{
	    if(fgets(buf,BUFFSIZE-1,fp)==NULL) break;
	    if(strncmp(buf,"From ",5)==0){
		f=s=NULL;
		for(;;){
		    if((p=fgets(buf,BUFFSIZE-1,fp))==NULL
		       ||buf[0]=='\n'||buf[0]=='\0')
			break;
		    if((strncmp(buf,"From:",5)==0)||
                       (strncmp(buf,"FROM:",5)==0))
                    {
			strcpy(bufs,buf);
			for(i=0;i<5;i++){
			    fgetpos(fp,&pos);
			    if((p=fgets(buf,BUFFSIZE-1,fp))==NULL
			       ||buf[0]=='\n'||buf[0]=='\0'){
				ed_fl=True;
				break;
			    }
			    if(bufs[strlen(bufs)-1]!='\n'){
				strcat(bufs,buf); /* Ԥ200byteʾ */
			    }
			    else if((buf[0]==' ') || (buf[0]=='\t')){
				bufs[strlen(bufs)-1]='\0';
				sdel = &buf[1];     /* \t  */
				strcat(bufs,sdel); /* ʣ */
			    }
			    else{
				f=XtNewString(bufs);
				fsetpos(fp,&pos);
				break;
			    }
			}
			if(ed_fl) break;
		    }
		    else if((strncmp(buf,"Subject:",8)==0)||
			    (strncmp(buf,"SUBJECT:",8)==0))
		    {
			strcpy(bufs,buf);
			for(i=0;i<5;i++){
			    fgetpos(fp,&pos);
			    if((p=fgets(buf,BUFFSIZE-1,fp))==NULL
			       ||buf[0]=='\n'||buf[0]=='\0'){
				ed_fl=True;
				break;
			    }
			    if(bufs[strlen(bufs)-1]!='\n'){
				strcat(bufs,buf); /* Ԥ200byteʾ */
			    }
			    else if((buf[0]==' ') || (buf[0]=='\t')){
				bufs[strlen(bufs)-1]='\0';
				sdel = &buf[1];     /* \t  */
				strcat(bufs,sdel); /* ʣ */
			    }
			    else{
				s=XtNewString(bufs);
				fsetpos(fp,&pos);
				break;
			    }
			}
			if(ed_fl) break;
		    } 
		}

		/*
		 * From: Subject:
		 * νɽ
		 */
		if (f) {
		    froms=strbuf(f);
		    XtFree(f);
		}
		else{
		    froms=strbuf("(no From: in original)\n");
		}
		if (s) {
		    froms=strbuf(" ");
		    froms=strbuf(s);
		    XtFree(s);
		}
		else{
		    froms=strbuf(" (no Subject: in original)\n");
		}

	    }
	    while (p != NULL && buf[0] != '\n' && buf[0] != '\0')
	      p = fgets(buf, BUFFSIZE - 1, fp);
	} while (1);
	fclose(fp);

#ifdef I18N    
    if(strcmp(biff_filter_com,"\0")!=0){
	set_biff_filter(biff_filter_com);
	froms=code_conv(froms);
    }
#endif

#if 0
	XtVaSetValues(mailwin_text, XtNstring, XtNewString(froms), NULL);
#endif
	XtVaSetValues(mailwin_text, XtNstring, froms, NULL);
    }
}

/* Qmail  */
void fs_get_qmail(char *mh_dir){
    FILE *fp_folder;
    char buf[BUFFSIZE],tmp[10],bufs[BUFFSIZE5];
    char folder_file[BUFFSIZE],folder_tmp[BUFFSIZE];
    char *froms=NULL, *p;
    Boolean ed_fl=False;
    fpos_t pos;
    int i;
    DIR *dp;
    struct dirent *entry;

    char *f, *s, *sdel;

    froms=strbuf(NULL);

    if ((dp=opendir(mailbox->path))==NULL){
	return;
    }	
    

    while((entry=readdir(dp))!=NULL){
	f=s=NULL;
	if(entry->d_name[0]!='.'){
	    sprintf(folder_file,"%s/%s",mailbox->path,entry->d_name);

	    if((fp_folder=fopen(folder_file,"r"))!=NULL){
		while(!feof(fp_folder)){
		    if((p=fgets(buf,BUFFSIZE-1,fp_folder))==NULL
		       ||buf[0]=='\n'||buf[0]=='\0')
			break;
		    if((strncmp(buf,"From:",5)==0)||
                       (strncmp(buf,"FROM:",5)==0))
                    {
			strcpy(bufs,buf);
			for(i=0;i<5;i++){
			    fgetpos(fp_folder,&pos);
			    if((p=fgets(buf,BUFFSIZE-1,fp_folder))==NULL
			       ||buf[0]=='\n'||buf[0]=='\0'){
				ed_fl=True;
				break;
			    }
			    if(bufs[strlen(bufs)-1]!='\n'){
				strcat(bufs,buf); /* Ԥ200byteʾ */
			    }
			    else if((buf[0]==' ') || (buf[0]=='\t')){
				bufs[strlen(bufs)-1]='\0';
				sdel = &buf[1];     /* \t  */
				strcat(bufs,sdel); /* ʣ */
			    }
			    else{
				f=XtNewString(bufs);
				fsetpos(fp_folder,&pos);
				break;
			    }
			}
			if(ed_fl) break;
		    }
		    else if((strncmp(buf,"Subject:",8)==0)||
			    (strncmp(buf,"SUBJECT:",8)==0))
                    {
			strcpy(bufs,buf);
			for(i=0;i<5;i++){
			    fgetpos(fp_folder,&pos);
			    if((p=fgets(buf,BUFFSIZE-1,fp_folder))==NULL
			       ||buf[0]=='\n'||buf[0]=='\0'){
				ed_fl=True;
				break;
			    }
			    if(bufs[strlen(bufs)-1]!='\n'){
				strcat(bufs,buf); /* Ԥ200byteʾ */
			    }
			    else if((buf[0]==' ') || (buf[0]=='\t')){
				bufs[strlen(bufs)-1]='\0';
				sdel = &buf[1];     /* \t  */
				strcat(bufs,sdel); /* ʣ */
			    }
			    else{
				s=XtNewString(bufs);
				fsetpos(fp_folder,&pos);
				break;
			    }
			}
			if(ed_fl) break;
		    } 
		}
		fclose(fp_folder);
		/*
		 * From: Subject:
		 * νɽ
		 */
		if (f) {
		    froms=strbuf(f);
		    XtFree(f);
		}
		else{
		    froms=strbuf("(no From: in original)\n");
		}
		if (s) {
		    froms=strbuf(" ");
		    froms=strbuf(s);
		    XtFree(s);
		}
		else{
		    froms=strbuf("(no Subject: in original)\n");
		}

	    }
	}
	
    }
    closedir(dp);

#ifdef I18N    
    if(strcmp(biff_filter_com,"\0")!=0){
	set_biff_filter(biff_filter_com);
	froms=code_conv(froms);
    }
#endif
    
#if 0
    XtVaSetValues(mailwin_text, XtNstring, XtNewString(froms), NULL);
#endif
    XtVaSetValues(mailwin_text, XtNstring, froms, NULL);
}


/* ʸɲó */
char* strbuf(char *p)
{
        static char    *start = NULL;
        static char    *next;
        static int      len, len2, l;

        if (p == NULL) {
                len = len2 = 4096;
                start = next = (char *) XtMalloc(len + 1);
                start[0] = '\0';
        } else if (start != NULL) {
                l = strlen(p);
                while (len - l < 0) {
                        char           *p;
                        len2 += 256;
                        len += 256;
                        p = (char *) XtRealloc(start, len2 + 1);
                        start = p;
                        next = p + len2 - len;
                }
                strcpy(next, p);
                len -= l;
                next += l;
        }
        return start;
}


#ifdef I18N    
/* ե륿ޥɸƤӤ */
static char* code_conv( char *data )
{
    FILE *fp;
    char buf[BUFFSIZE];
    int fd1[2],fd2[2];
    static pid_t pid1,pid2;
    char *p;
    
    pipe(fd1);
    pipe(fd2);

    child_fl = 1;    
    waitpid(pid1,0,WNOHANG);
    waitpid(pid2,0,WNOHANG);
    if( (pid1 = fork()) < 0 ){
	perror("fork");	exit(1);
    }
    /*waitpid(pid,0,WNOHANG);*/

	/* ҥץ */
    if( pid1 == 0 ){
	close( fd1[1] );
	close( fd2[0] );
	close(0);
	dup(fd1[0]);
	close(fd1[0]);
	close(1);
	dup(fd2[1]);
	close(fd2[1]);
	execvp( biff_filter[0], &biff_filter[1] );
	perror("execvp");
	exit(1);
    }
    
    if( (pid2 = fork()) < 0 ){
	perror("fork");	exit(1);
    }
    
    /* ƤΣ */
    if( pid2 == 0 ){
	close( fd2[1] );
	close( fd2[0] );
	close( fd1[0] );
	
	if( (fp = fdopen( fd1[1], "w" )) != NULL ){
	    fputs( data, fp );
	    fclose( fp );
	}
	exit(1);
    }
    

    /* ƤΣ */
    close( fd1[1] );
    close( fd1[0] );
    close( fd2[1] );
    
    if( (p = strbuf(NULL)) != NULL ){
	if( (fp = fdopen( fd2[0], "r" )) != NULL ){
	    while( fgets( buf,BUFFSIZE-1,fp ) != NULL )
		p = strbuf( buf );
	    fclose( fp );
	}
    }
    return p;
}


void set_biff_filter(char* com){
  int             t, i;
  char           *p;
  static int imax;
  
  biff_filter[0] = NULL;

  for(i=0;i<12;i++){
    XtFree(biff_filter[i]);
  }
  if (strcmp(com,"\0")!=0) {
    set_token(com);
    if ((t = get_token2()) != NODAT) {
      biff_filter[0] = XtNewString(token_buf);
      
      if ((p = strrchr(biff_filter[0], '/')) != NULL)
	p++;
      else
	p = biff_filter[0];
      biff_filter[1] = p;
      
      for (i = 2; i < 12;) {
	if ((t = get_token2()) == NODAT) {
	  biff_filter[i] = (char *) NULL;
	  break;
	    } 
	else{
	  biff_filter[i++] = XtNewString(token_buf);
	}
      }
      imax=i;;
    }
  }
}

void  set_token(char *p){
    token_p = p;
}

int get_token2(void)
{
    char            ch;
    
    while ((ch = *token_p++) == ' ' || ch == '\t' || ch == '\n');
    
    if (ch == '\0')
	return NODAT;
    
    if (ch == '"') {
	char           *p = token_buf;
	for (;;) {
	    ch = *token_p++;
	    if (ch == '"')
		break;
	    else if (ch == '\\') {
		ch = *token_p++;
	    }
	    if (ch == '\n' || '\0')
		return NODAT;
	    *p++ = ch;
	}
	*p = '\0';
	return STRING;
    } else {
	char           *p = token_buf;
	*p++ = ch;
	while (!((ch = *token_p) == ' ' || ch == '\t' || ch == '\n' || ch == '\0')) {
	    *p++ = ch;
	    token_p++;
		}
	*p = '\0';
	return ID;
    }
}
#endif /* I18N */
